import {ImapFlow} from "imapflow";
import type {Awaitable} from "../bones";
import {config} from "../config.ts";

export async function withClient<T>(cb: (client: ImapFlow) => Awaitable<T>): Promise<T> {
    const client = new ImapFlow({
        ...config.mail.imap,
        logger: false,
    })

    await client.connect()

    let result: T
    try {
        result = await cb(client)
    } finally {
        await client.logout()
    }
    return result
}
